with Ada.Text_IO, Ada.Numerics.Discrete_Random;
use Ada.Text_IO;

procedure philo is

   ------------------- Gestion de durees aleatoires
   package Alea_Int is new Ada.Numerics.Discrete_Random (Natural);
   use Alea_Int;
   
   Graine : Generator;

   function Duree_Attente return Duration is
   begin
      return 0.1 * Duration (Random (Graine) mod 10);
   end Duree_Attente;
   ----------------------------------------------------

-- nombre de philosophes
nb_philos : constant Natural := 6;
-- nombre de repas
nb_repas : constant Natural := 4;

task type philosophe is
  entry init(id : Natural);
end philosophe;

protected type fourchette is
  entry prendre(id_philo : natural; id_fourchette : natural);
  procedure rendre(id_philo : natural; id_fourchette : natural);
  private
    disponible : boolean := true;
end fourchette;

tab_philo : array (1..nb_philos) of philosophe;
tab_fourchette : array(0..nb_philos-1) of fourchette;
	
-- A completer

end philo;